# Hunter's Save Position Addon
#  
# Install instructions:
#       1. Install Mattie's EventScripts 2.0 plugin:
#           http://mattie.info/cs/
#
#       2. Copy and upload this script to:
#           <gamedir>/addons/eventscripts/save_position/
#
#       3. Add the following line somewhere in autoexec.cfg:
#           es_load save_position
#
################################################################################
#import EventScripts
import es
#import Libraries
import vecmath
import popuplib
import playerlib
import effectlib
import gamethread
import time
#import Psyco Compiler
import psyco
psyco.full()

# Addon Information
info = es.AddonInfo()
info.name = "Save Position"
info.version = "2.0.0"
info.author = "Hunter"
info.url = "http://addons.eventscripts.com/addons/user/289"
info.description = "Allows you to save your location and get back"
info.basename = "save_position"

hunter_save_position_ver        = info.version
hunter_save_position_text       = 'Hunters '+info.name+', www.sourceplugins.de, '+info.version+', ES 2.0.0.247+ (Python Version)'

# Server Variables
save_position_limit             = es.ServerVar('save_position_limit', '15', 'How much positions should be showen in the position menu?')
save_position_protect           = es.ServerVar('save_position_protect', '1', 'Protect spawn area?')
save_position_protect_radius    = es.ServerVar('save_position_protect_radius', '1000', 'Protected area radius?')
save_position_protect_draw      = es.ServerVar('save_position_protect_draw', '1', 'Show the protected area ingame?')

# Help Popup
save_position_help              = popuplib.create('save_position_help')
save_position_help.addline('Save Position')
save_position_help.addline('    User Commands:')
save_position_help.addline('------------------')
save_position_help.addline('->1. !sphelp')
save_position_help.addline('->2. !save [name]')
save_position_help.addline('->3. !go')
save_position_help.addline('->4. !delete')
save_position_help.addline('->5. !killme')
save_position_help.addline('->6. !specme')
save_position_help.addline('------------------')
save_position_help.addline('You can use the')
save_position_help.addline('commands in your')
save_position_help.addline('console or the chat!')
save_position_help.addline('------------------')
save_position_help.addline('->0. Cancel')

# Global Variables
save_position_positions         = {}
save_position_spawns            = {1:[],2:[],3:[]}
save_position_popups            = {}

def load():
    public = es.ServerVar('hu_sp', info.version, info.name)
    public.makepublic()

    es.regsaycmd('!sphelp', 'save_position/help', 'Save Position Help')
    es.regsaycmd('!save', 'save_position/saveloc', 'Save a new position')
    es.regsaycmd('!go', 'save_position/teleport', 'Go to a saved position')
    es.regsaycmd('!tele', 'save_position/teleport', 'Go to a saved position')
    es.regsaycmd('!delete', 'save_position/delete', 'Delete a saved position')
    es.regsaycmd('!killme', 'save_position/killme', 'Kill yourself')
    es.regsaycmd('!specme', 'save_position/specme', 'Switch to spectators')

    es.log(hunter_save_position_text)
    es.msg('#multi', '#green[SavePosition] #defaultLoaded')
    
def unload():
    for popup in save_position_popups:
        save_position_popups[popup].delete()

    gamethread.cancelDelayed('save_position')

    es.unregsaycmd('!sphelp')
    es.unregsaycmd('!save')
    es.unregsaycmd('!go')
    es.unregsaycmd('!tele')
    es.unregsaycmd('!delete')
    es.unregsaycmd('!killme')
    es.unregsaycmd('!specme')
    es.msg('#multi', '#green[SavePosition] #defaultUnloaded') 

def es_map_start(event_var):
    save_position_positions = {}
    save_position_spawns = {1:[],2:[],3:[]}

def es_client_command(event_var):
    if (str(event_var['command']) == '!hunter_save_position_ver') or (str(event_var['command']) == '!hunter_all_ver'):
        es.cexec(int(event_var['userid']), 'echo '+hunter_save_position_text)

def player_activate(event_var):
    gamethread.delayed(30, es.cexec, (int(event_var['userid']), 'echo '+hunter_save_position_text))

def player_spawn(event_var):
    if int(event_var['es_userteam']) > 0 and not vecmath.vector(es.getplayerlocation(int(event_var['userid']))) in save_position_spawns[int(event_var['es_userteam'])]:
        save_position_spawns[int(event_var['es_userteam'])].append(vecmath.vector(es.getplayerlocation(int(event_var['userid']))))

def player_disconnect(event_var):
    if int(event_var['userid']) in save_position_positions:
        del save_position_positions[int(event_var['userid'])]
    if int(event_var['userid']) in save_position_popups:
        del save_position_popups[int(event_var['userid'])]

def round_start(event_var):
    gamethread.delayed(5, es.msg, ('#multi', '#green[SavePosition] #lightgreenThis server is running in teleport mode! Type #green\'!sphelp\' #lightgreenfor info'))
    gamethread.delayed(8, es.msg, ('#multi', '#green[SavePosition] #lightgreenTeleported players are #greennot #lightgreencheating#lightgreen!'))
    gamethread.cancelDelayed('save_position')

    if int(save_position_protect):
        gamethread.delayed(11, es.msg, ('#multi', '#green[SavePosition] #lightgreenSpawn protection area is #greenenabled#lightgreen!'))
        gamethread.delayedname(3, 'save_position', _draw_spawn)

def help():
    save_position_help.send(es.getcmduserid())
    
def saveloc():
    player = playerlib.getPlayer(es.getcmduserid())
    if int(player.attributes['isdead']) == 0:
        if int(player.attributes['teamid']) > 0:
            args = ''
            for index in range(1, es.getargc()):
                args += es.getargv(index)+' '
            if int(player.attributes['teamid']) == 1:
                teams = (2, 3)
            elif int(player.attributes['teamid']) == 2:
                teams = (1, 3)
            elif int(player.attributes['teamid']) == 3:
                teams = (1, 2)
            if not int(save_position_protect) or (not len(save_position_spawns[teams[0]]) or (vecmath.vector(es.getplayerlocation(int(player)))-_sum_vector(save_position_spawns[teams[0]])).length() > int(save_position_protect_radius)) and (not len(save_position_spawns[teams[1]]) or (vecmath.vector(es.getplayerlocation(int(player)))-_sum_vector(save_position_spawns[teams[1]])).length() > int(save_position_protect_radius)):
                if not player.uniqueid() in save_position_positions:
                    save_position_positions[player.uniqueid()] = []
                if len(save_position_positions[player.uniqueid()]) >= int(save_position_limit):
                    save_position_positions[player.uniqueid()].pop()
                if len(args.replace('!saveloc', '').strip()):
                    save_position_positions[player.uniqueid()].insert(0, {'name':args.replace('!saveloc', '').strip(), 'vector':es.getplayerlocation(int(player)), 'time':time.localtime()})
                else:
                    save_position_positions[player.uniqueid()].insert(0, {'name':time.strftime('%Y-%m-%d %H:%M:%S'), 'vector':es.getplayerlocation(int(player)), 'time':time.localtime()})
                es.tell(int(player), '#multi', '#green[SavePosition] #defaultLocation saved at #lightgreen%s' % time.strftime('%Y-%m-%d %H:%M:%S'))
            else:
                es.tell(int(player), '#multi', '#green[SavePosition] #defaultYou cannot save a position near an other teams spawn!')
        else:
            es.tell(int(player), '#multi', '#green[SavePosition] #defaultYou cannot save a position while you are spectating!')
    else:
        es.tell(int(player), '#multi', '#green[SavePosition] #defaultYou cannot save a position while dead!')

def teleport():
    player = playerlib.getPlayer(es.getcmduserid())
    if int(player.attributes['isdead']) == 0:
        if int(player.attributes['teamid']) > 0:
            if player.uniqueid() in save_position_positions:
                save_position_popups[int(player)] = popuplib.easymenu('save_position_%s'%int(player), None, _select_teleport)
                save_position_popups[int(player)].settitle('Save Position\nChoose a target location')
                save_position_popups[int(player)].vguititle = 'Save Position - Choose a target location'
                for position in save_position_positions[player.uniqueid()]:
                    save_position_popups[int(player)].addoption(position, position['name'])
                save_position_popups[int(player)].send(int(player))
            else:
                es.tell(int(player), '#multi', '#green[SavePosition] #defaultNo location saved!')
        else:
            es.tell(int(player), '#multi', '#green[SavePosition] #defaultYou cannot teleport while you are spectating!')
    else:
        es.tell(int(player), '#multi', '#green[SavePosition] #defaultYou cannot teleport while dead!')

def _select_teleport(userid, choice, popupid):
    player = playerlib.getPlayer(userid)
    if int(player.attributes['isdead']) == 0:
        if int(player.attributes['teamid']) > 0:
            gamethread.queue(player.set, ('location', list(choice['vector'])))
            es.tell(int(player), '#multi', '#green[SavePosition] #defaultTeleported to location \'%s\' saved at #lightgreen%s' % (choice['name'], time.strftime('%Y-%m-%d %H:%M:%S', choice['time'])))
        else:
            es.tell(int(player), '#multi', '#green[SavePosition] #defaultYou cannot teleport while you are spectating!')
    else:
        es.tell(int(player), '#multi', '#green[SavePosition] #defaultYou cannot teleport while dead!')

def delete():
    player = playerlib.getPlayer(es.getcmduserid())
    if player.uniqueid() in save_position_positions:
        save_position_popups[int(player)] = popuplib.easymenu('save_position_%s'%int(player), None, _select_delete)
        save_position_popups[int(player)].settitle('Save Position\nChoose a location to delete')
        save_position_popups[int(player)].vguititle = 'Save Position - Choose a location to delete'
        for position in save_position_positions[player.uniqueid()]:
            save_position_popups[int(player)].addoption(position, position['name'])
        save_position_popups[int(player)].send(int(player))
    else:
        es.tell(int(player), '#multi', '#green[SavePosition] #defaultNo location saved!')

def _select_delete(userid, choice, popupid):
    player = playerlib.getPlayer(userid)
    if player.uniqueid() in save_position_positions:
        if choice in save_position_positions[player.uniqueid()]:
            save_position_positions[player.uniqueid()].remove(choice)
            if not len(save_position_positions[player.uniqueid()]):
                del save_position_positions[player.uniqueid()]
            es.tell(int(player), '#multi', '#green[SavePosition] #defaultDeleted location \'%s\' saved at #lightgreen%s' % (choice['name'], time.strftime('%Y-%m-%d %H:%M:%S', choice['time'])))
    else:
        es.tell(int(player), '#multi', '#green[SavePosition] #defaultNo location saved!')

def killme():
    es.sexec(es.getcmduserid(), 'kill')

def specme():
    es.server.cmd('es_xfire %s !self setteam 1' % es.getcmduserid())

def _sum_vector(list):
    _sum = None
    _count = 0
    for vector in list:
        _count += 1
        if _sum:
            _sum += vector
        else:
            _sum = vector
    if _count:
        _sum /= _count
    return _sum

def _draw_spawn(offset=-32*10):
    if offset > 32*10:
        offset = 0
    if len(save_position_spawns[1]):
        vector = _sum_vector(save_position_spawns[1])
        vector['z'] += offset
        gamethread.queue(effectlib.drawCircle, (list(vector), int(save_position_protect_radius)), {'seconds':3, 'red':0, 'green':255, 'blue':0})
    if len(save_position_spawns[2]):
        vector = _sum_vector(save_position_spawns[2])
        vector['z'] += offset
        gamethread.queue(effectlib.drawCircle, (list(vector), int(save_position_protect_radius)), {'seconds':3, 'red':255, 'green':0, 'blue':0})
    if len(save_position_spawns[3]):
        vector = _sum_vector(save_position_spawns[3])
        vector['z'] += offset
        gamethread.queue(effectlib.drawCircle, (list(vector), int(save_position_protect_radius)), {'seconds':3, 'red':0, 'green':0, 'blue':255})
    gamethread.delayedname(1, 'save_position', _draw_spawn, (offset+32))
